#ifndef FARBEN_H
#define FARBEN_H

/****************************************************************
 *																															*
 * Filename : Farben.h																					*
 *																															*
 ****************************************************************
 *																															*
 *	Comment : Diese Datei beinhaltet die FarbenFilestruktur.		*
 *						Diese Struktur ist so aufgebaut, dass sie IFF			*
 *						Interchange File Format ) kompatibel ist.					*
 *						Nhere Informationen knnen aus der Struktur			*
 *						entnommen werden sowie aus der Dokumentation			*
 *						von Commodore.																		*
 *																															*
 *			Rev : V1.0																							*
 *																															*
 *	History : V1.0 erstellen dieses Files							01.06.89	*
 *																															*
 *			Doc :																										*
 *																															*
 *		 Bugs : keine bekannten																		*
 *																															*
 *		Autor : Oesch Silvano																			*
 *																															*
 *		Datum : 01.06.89																					*
 *																															*
 ****************************************************************/


/****************************************************************
 *																															*
 * allgemeine Includedateien																		*
 *																															*
 ****************************************************************/

#include <iff/ilbm.h>

/****************************************************************
 *																															*
 * programmspezifische Includedateien														*
 *																															*
 ****************************************************************/

#include "Definitions.h"

/****************************************************************
 *																															*
 * programmspezifische Strukturen																*
 *																															*
 ****************************************************************/

struct FarbenFile										/* Strukturname							*/
	{
		long kopf;											/* IFF Header 'FORM'				*/
		long groesse;										/* Grsse der Datei					*/
		long id;												/* IFF ID 'ILBM'						*/
		long colormapheader;						/* IFF Kennzeichnung 'CMAP'	*/
		long anzahl;										/* Anzahl Farbregister * 4	*/
		ColorRegister colorregister[FARBENANZAHL];
																		/* Farbdaten								*/
	};

#endif FARBEN_H
