#ifndef DEBUGL2_H
#define DEBUGL2_H

/****************************************************************
*																																*
*	 Filename : DebugL2.h																					*
*																																*
*****************************************************************
*																																*
*		Comment : Includedatei fr Debugfunktionen Level 2					*
*							Diese Funktionen helfen dem Programmierer die			*
*							geladenen Daten der Plotlibrary anzuschauen. Es		*
*							kann bei einer Implementation auf einen neuen			*
*							Rechner die Darstellung kontrolliert werden.			*
*							Diese Funktionen sollten nur whrend dieser				*
*							Implementationsphase verwendet werden, da sie			*
*							sehr gross sind und normalerweise auch nicht			*
*							bentigt werden.																	*
*																																*
*				Rev : V1.0																							*
*																																*
*		History : V1.0 erstellen dieses Files							15/11/89	*
*																																*
*				Doc : Plotlibrary User's Guide													*
*																																*
*			 Bugs : keine bekannten																		*
*																																*
*			Autor : Oesch Silvano																			*
*																																*
*			Datum : 10/12/89																					*
*																																*
****************************************************************/

/****************************************************************
*																																*
*	Plotlibrary Includefiles																			*
*																																*
****************************************************************/

#ifndef PLOT_H
#define LISTL2_H
#define PLERROR_H
#include <plot/plot.h>
#endif

/****************************************************************
*																																*
*	Definition der Funktionsparameter															*
*																																*
****************************************************************/

#if PROTOTYPEN

void displaydata(int );
void displaycurve(int );
void dispdata(struct Curve *);
void dispplot(void);
void dispcurve(struct Curve *);

#else

void displaydata();
void displaycurve();
void dispdata();
void dispplot();
void dispcurve();

#endif

#endif
