#ifndef PLERROR_H
#define PLERROR_H

/****************************************************************
*																																*
*	 Filename : Plerror.h																					*
*																																*
*****************************************************************
*																																*
*		Comment : Alle Errordefinitionen fr die Fehlerbehandlung		*
*							der Plotlibrary. Wenn die Get_Ploterror()-				*
*							bentzt wird, muss diese Includedatei eingelesen	*
*			        werden.																						*
*							In jedem File der Plotlibrary muss das File auch	*
*							geladen werden.																		*
*																																*
*				Rev : V1.0																							*
*																																*
*		History : V1.0 erstellen dieses Files							14/11/89	*
*																																*
*				Doc :	Plotlibrary User's Guide													*
*																																*
*			 Bugs : keine bekannten																		*
*																																*
*			Autor : Oesch Silvano																			*
*																																*
*			Datum : 14/11/89																					*
*																																*
****************************************************************/

/****************************************************************
*																																*
*	Errormacro																										*
*																																*
****************************************************************/

#define seterror(nbr) plerr = nbr
#define setreturn(err) returnset = err

/****************************************************************
*																																*
*	PlotError Fehler																							*
*																																*
****************************************************************/

#define MAXERR			59							/* max. Fehlercode					*/

#define PLERROR			0								/* Ploterror failure				*/
#define NOERROR			39							/* no error									*/

/****************************************************************
*																																*
*	OpenPlot Fehler																								*
*																																*
****************************************************************/

#define SEQOPPLOT		1								/* Sequence error						*/
#define MEMOPPLOT		2								/* Memory allocation				*/

/****************************************************************
*																																*
*	ClosePlot Fehler																							*
*																																*
****************************************************************/

#define SEQCLOSE		3								/* Sequnce error						*/

/****************************************************************
*																																*
*	LoadData Fehler																								*
*																																*
****************************************************************/

#define SEQLODATA		3								/* Sequence error						*/
#define	PARALODATA	5								/* Parameter failure				*/
#define	FILEODATA		11							/* File not found						*/
#define	INVFILESTR	12							/* Invalid File Structur		*/
#define	INVFILETYP	13							/* Invalid File Typ					*/
#define NOTYPEQ			14							/* type not equal						*/
#define INVDATAS		15							/* invalid datas						*/
#define REALFAIL		16							/* reallocation failed			*/
#define MORENOTALL	17							/* more curveload not allow	*/

/****************************************************************
*																																*
*	GetData Fehler																								*
*																																*
****************************************************************/

#define SEQGEDATA		3								/* Sequence error						*/
#define PARAGEDATA	5								/* Parameter failure				*/
#define INVTYPGDATA	18							/* only 2D allowed					*/

/****************************************************************
*																																*
*	DelData Fehler																								*
*																																*
****************************************************************/

#define SEQDEDATA		4								/* Sequence error						*/
#define PARADEDATA	5								/* Parameter failure				*/
#define	NOTFOUND		6								/* Curve not found					*/

/****************************************************************
*																																*
*	SetAxisName Fehler																						*
*																																*
****************************************************************/

#define SEQAXNAME		3								/* Sequence error						*/
#define PARAXNAME		5								/* Parameter failure				*/
#define NONAMETYP		7								/* name not allowed for typ	*/
#define NAMTOBIG		8								/* name to big							*/
#define NONAMGIV		9								/* no name given						*/
#define NOMEMNAM		2								/* memory alloc failed			*/
#define STRALLSET		10							/* String already set				*/

/****************************************************************
*																																*
*	SetValue Fehler																								*
*																																*
****************************************************************/

#define SEQSEVAL		3								/* Sequence error						*/
#define PARASEVAL		5								/* Parameter failure				*/
#define VALTOLOW		19							/* value to low							*/
#define VALTOHIGH		20							/* value to high						*/

/****************************************************************
*																																*
*	GetValue Fehler																								*
*																																*
****************************************************************/

#define SEQGEVAL		3								/* Sequence error						*/
#define PARAGEVAL		5								/* Parameter failure				*/

/****************************************************************
*																																*
*	SetAutoval Fehler																							*
*																																*
****************************************************************/

#define SEQAUVAL		3								/* Sequence error						*/
#define PARAAUVAL		5								/* Parameter failure				*/

/****************************************************************
*																																*
*	SetGrid Fehler																								*
*																																*
****************************************************************/

#define SEQSEGRID		3								/* Sequence error						*/
#define PARASEGRID	5								/* Parameter failure				*/

/****************************************************************
*																																*
*	SetFill Fehler																								*
*																																*
****************************************************************/

#define SEQSEFILL		3								/* Sequence error						*/
#define PARASEFILL	5								/* Parameter failure				*/

/****************************************************************
*																																*
*	SetMes Fehler																									*
*																																*
****************************************************************/

#define SEQSEMES		3								/* Sequence error						*/
#define PARASEMES		5								/* Parameter failure				*/
#define INVTYP			27							/* neg Val not allowed			*/

/****************************************************************
*																																*
*	SetUnit Fehler																								*
*																																*
****************************************************************/

#define SEQSEUNI		3								/* Sequence error						*/
#define PARASEUNI		5								/* Parameter failure				*/

/****************************************************************
*																																*
*	SetTitel Fehler																								*
*																																*
****************************************************************/

#define SEQSETIT		3								/* Sequence error						*/

/****************************************************************
*																																*
*	SetCurvename Fehler																						*
*																																*
****************************************************************/

#define SEQCURNAM		3								/* Sequence error						*/
#define PARACURNAM	5								/* Parameter failure				*/
#define CURCURNAM		6								/* Curve not found					*/

/****************************************************************
*																																*
*	SetCurveColor Fehler																					*
*																																*
****************************************************************/

#define SEQCURCOL		4								/* Sequence error						*/
#define PARACURCOL	5								/* Parameter failure				*/
#define CURCURCOL		6								/* Curve not found					*/

/****************************************************************
*																																*
*	getcurve Fehler																								*
*																																*
****************************************************************/

#define MEMGETDATA	2								/* memory allocation fail		*/
#define INVCURTYP		22							/* invalid curve type				*/

/****************************************************************
*																																*
*	set3doptions Fehler																						*
*																																*
****************************************************************/

#define SEQ3DOPT		3								/* sequence error						*/
#define PARA3DOPT		5								/* parameter failure				*/

/****************************************************************
*																																*
*	setplotsize Fehler																						*
*																																*
****************************************************************/

#define SEQSEPLO		3								/* sequence error						*/
#define PARASEPLO		5								/* parameter failure				*/

/****************************************************************
*																																*
*	Display Fehler																								*
*																																*
****************************************************************/

#define SEQDISP			4								/* Sequence error						*/
#define PARADISP		5								/* Parameter failure				*/
#define NOTIMP			23							/* not implemented					*/
#define INVDISPARA	24							/* invalid display para			*/
#define GRAPHNOTOP	25							/* graphic not open					*/
#define GRAPHNOTEQ	26							/* displaypara not equal		*/
#define NOPLDATA		28							/* no plotdatas specified		*/
#define HIDDENMEM		29							/* no mem for hidden alg.		*/

/****************************************************************
*																																*
*	Level 3 Fehler																								*
*																																*
****************************************************************/

#define GROPER			40							/* graphic open failure			*/
#define GRAPHMEM		41							/* graphic alloc failure		*/
#define GRAPHFILL		42							/* polygon fill failure			*/
#define PLOPER			45							/* plotdfile open failure		*/
#define PLSIZE			46							/* plotsize not in range		*/

#endif

