#ifndef SUPPL2_H
#define SUPPL2_H

/****************************************************************
*																																*
*	 Filename : SuppL2.h																					*
*																																*
*****************************************************************
*																																*
*		Comment : Includedatei fr die Supportfunktionen fr den		*
*							Level 2																						*
*																																*
*				Rev : V1.0																							*
*																																*
*		History : V1.0 erstellen dieses Files							01/01/90	*
*																																*
*				Doc : Plotlibrary User's Guide													*
*																																*
*			 Bugs : keine bekannten																		*
*																																*
*			Autor : Oesch Silvano																			*
*																																*
*			Datum : 01/01/90																					*
*																																*
****************************************************************/

/****************************************************************
*																																*
*	Definition der globalen Funktionszeiger												*
*																																*
****************************************************************/

#if PROTOTYPEN

extern int	(*OpenGraphics)(void),
						(*GetMaxColor)(void),
						(*GetMaxX)(void),
						(*GetMaxY)(void),
						(*GetFgColor)(void),
						(*GetBackColor)(void),
						(*GetTextSize)(int ),
						(*FillPolyLine)(int ,GPT *);
extern void	(*CloseGraphics)(void),
						(*SetTextSize)(void),
						(*DrawText)(int ,int ,char *),
						(*ClearGraphics)(void),
						(*SetFgColor)(int ),
						(*SetBackColor)(int ),
						(*DrawLine)(int ,int ,int ,int ),
						(*DrawPolyLine)(int ,GPT *),
						(*DrawRectangle)(int ,int ,int ,int ),
						(*SetFillStyle)(int ),
						(*SetLineStyle)(int );

extern DATA	(*xexpfct)(DATA ),
						(*xlogfct)(DATA ),
						(*yexpfct)(DATA ),
						(*ylogfct)(DATA ),
						(*zexpfct)(DATA ),
						(*zlogfct)(DATA );

#else

extern int	(*OpenGraphics)(),			/* ffnet Graphik						*/
						(*GetMaxColor)(),				/* max. Farbanzahl					*/
						(*GetMaxX)(),						/* max. X Auflsung					*/
						(*GetMaxY)(),						/* max. Y Auflsung					*/
						(*GetFgColor)(),				/* Vordergrundfarbe					*/
						(*GetBackColor)(),			/* Hintergrundfarbe					*/
						(*GetTextSize)(),				/* Textgrsse								*/
						(*FillPolyLine)();			/* ausgeflltes Vieleck			*/
extern void	(*CloseGraphics)(),			/* schliesst Graphik				*/
						(*SetTextSize)(),				/* setzt Text								*/
						(*DrawText)(),					/* schreibt Text						*/
						(*ClearGraphics)(),			/* lscht Bildschirm				*/
						(*SetFgColor)(),				/* setzt Vordergrundfarbe		*/
						(*SetBackColor)(),			/* setzt Hintergrundfarbe		*/
						(*DrawLine)(),					/* zeichnet Linie						*/
						(*DrawRectangle)(),			/* zeichnet Rechteck				*/
						(*SetFillStyle)(),			/* setzt Fllmuster					*/
						(*SetLineStyle)();			/* setzt Linientyp					*/

extern DATA	(*xexpfct)(),
						(*xlogfct)(),
						(*yexpfct)(),
						(*ylogfct)(),
						(*zexpfct)(),
						(*zlogfct)();

#endif

/****************************************************************
*																																*
*	Funktionsmakros																								*
*																																*
****************************************************************/

#define printtextrel2d(a,b,c,d) printtextrel(a,b,c,NULL,d)
#define printexp2d(a,b,c,d,e) printexp(a,b,c,d,NULL,e)
#define printtextrel3d(a,b,c,d,e) printtextrel(a,b,c,d,e)
#define printexp3d(a,b,c,d,e,f) printexp(a,b,c,d,e,f)

/****************************************************************
*																																*
*	Definition der Funktionsparameter															*
*																																*
****************************************************************/

#if PROTOTYPEN

void initscfunction(void);
void initplfunction(void);
void textline2d(char *,DATA *,DATA *,DATA *,DATA *,int);
void textline3d(char *,DATA *,DATA *,DATA *,
								DATA *,DATA *,DATA *,int);
int tlinex2d(int,int,DATA *,DATA *,DATA *,DATA *,int);
int tlinex3d(int,int,DATA *,DATA *,DATA *,
							DATA *,DATA *,DATA *,int);
void getgraphics(void);
void resetgraphics(void);
void drawxaxis(void);
int drawyaxis(void);
void drawzaxis(void);
void calccolor(int );
DATA calclsize(DATA *,int ,int );
int round(DATA );
double getexp(DATA );
double getexpe(DATA );
DATA exp10(DATA );
void printtextrel(char *,DATA *,DATA *,DATA *,int );
int printexp(int ,int ,DATA *,DATA *,DATA *,int );
void printtextabs(char *,int ,int ,int );

#else

void initscfunction();
void initplfunction();
void textline2d();
void textline3d();
int tlinex2d();
int tlinex3d();
void getgraphics();
void resetgraphics();
void drawxaxis();
int drawyaxis();
void calccolor();
DATA calclsize();
int round();
double getexp();
double getexpe();
DATA exp10();
void printtextrel();
int printexp();
void printtextabs();

#endif

#endif
